summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorJaromil <jaromil@dyne.org>2011-09-04 13:50:04 (GMT)
committer Jaromil <jaromil@dyne.org>2011-09-04 13:50:04 (GMT)
commit2a8c715f923647e922bdf1f7a74f813076fbd04e (patch)
treec760300e139c19dff6e9bfaf0ba85da56843c454
parent212e3b5812f5f810e6127848c7b338ea18efe679 (diff)
updated to live-boot scripts 3.0~a20
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live1043
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live-bottom/08persistence_excludes4
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live-bottom/12fstab6
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live-bottom/23networking48
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live-bottom/24preseed13
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live-bottom/30accessibility41
-rw-r--r--dyneIII/live-init-scripts/scripts/live-functions20
-rw-r--r--dyneIII/live-init-scripts/scripts/live-helpers74
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live-premount/modules4
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live-premount/readonly2
-rwxr-xr-xdyneIII/live-init-scripts/scripts/live-premount/select_eth_device102
11 files changed, 860 insertions, 497 deletions
diff --git a/dyneIII/live-init-scripts/scripts/live b/dyneIII/live-init-scripts/scripts/live
index 7a69f43..82f5413 100755
--- a/dyneIII/live-init-scripts/scripts/live
+++ b/dyneIII/live-init-scripts/scripts/live
@@ -8,6 +8,7 @@ echo "/root/lib" >> /etc/ld.so.conf
echo "/root/usr/lib" >> /etc/ld.so.conf
mountpoint="/live/image"
+alt_mountpoint="/media"
LIVE_MEDIA_PATH="live"
root_persistence="live-rw"
@@ -20,6 +21,7 @@ USERFULLNAME="Live user"
HOSTNAME="host"
mkdir -p "${mountpoint}"
+tried="/tmp/tried"
# Create /etc/mtab for debug purpose and future syncs
if [ ! -d /etc ]
@@ -32,9 +34,6 @@ then
touch /etc/mtab
fi
-[ -f /etc/live.conf ] && . /etc/live.conf
-export USERNAME USERFULLNAME HOSTNAME
-
. /scripts/live-helpers
if [ ! -f /live.vars ]
@@ -45,37 +44,18 @@ fi
Arguments ()
{
PRESEEDS=""
+ LOCATIONS=""
for ARGUMENT in $(cat /proc/cmdline)
do
case "${ARGUMENT}" in
skipconfig)
NOACCESSIBILITY="Yes"
- NOAPPARMOR="Yes"
- NOAPTCDROM="Yes"
- NOAUTOLOGIN="Yes"
- NOCONSOLEKEYBOARD="Yes"
NOFASTBOOT="Yes"
NOFSTAB="Yes"
- NOGNOMEPANEL="Yes"
- NOHOSTS="Yes"
- NOJOCKEY="Yes"
- NOKPERSONALIZER="Yes"
- NOLANGUAGESELECTOR="Yes"
- NOLOCALES="Yes"
NONETWORKING="Yes"
- NOPOLKITCONF="Yes"
- NOPOWERMANAGEMENT="Yes"
- NOPROGRAMCRASHES="Yes"
- NOSUDO="Yes"
- NOTIMEZONE="Yes"
- NOUPDATENOTIFIER="Yes"
- NOUSER="Yes"
- NOXAUTOCONFIG="Yes"
- NOXAUTOLOGIN="Yes"
- NOXSCREENSAVER="Yes"
-
- export NOACCESSIBILITY NOAPPARMOR NOAPTCDROM NOAUTOLOGIN NOCONSOLEKEYBOARD NOFASTBOOT NOFSTAB NOGNOMEPANEL NOHOSTS NOJOCKEY NOKPERSONALIZER NOLANGUAGESELECTOR NOLOCALES NONETWORKING NOPOLKITCONF NOPOWERMANAGEMENT NOPROGRAMCRASHES NOSUDO NOTIMEZONE NOUPDATENOTIFIER NOUSER NOXAUTOCONFIG NOXAUTOLOGIN NOXSCREENSAVER
+
+ export NOACCESSIBILITY NOFASTBOOT NOFSTAB NONETWORKING
;;
access=*)
@@ -88,6 +68,10 @@ Arguments ()
export DEFCONSOLE
;;
+ BOOTIF=*)
+ BOOTIF="${x#BOOTIF=}"
+ ;;
+
debug)
DEBUG="Yes"
export DEBUG
@@ -95,26 +79,38 @@ Arguments ()
set -x
;;
+ dhcp)
+ # Force dhcp even while netbooting
+ # Use for debugging in case somebody works on fixing dhclient
+ DHCP="Force";
+ export DHCP
+ ;;
+
+ nodhcp)
+ unset DHCP
+ ;;
+
ethdevice=*)
DEVICE="${ARGUMENT#ethdevice=}"
- export DEVICE
+ ETHDEVICE="${DEVICE}"
+ export DEVICE ETHDEVICE
+ ;;
+
+ ethdevice-timeout=*)
+ ETHDEV_TIMEOUT="${ARGUMENT#ethdevice-timeout=}"
+ export ETHDEV_TIMEOUT
;;
fetch=*)
- FETCH="${ARGUMENT#fetch=}"
- export FETCH
- ;;
+ FETCH="${ARGUMENT#fetch=}"
+ export FETCH
+ ;;
forcepersistentfsck)
FORCEPERSISTENTFSCK="Yes"
export FORCEPERSISTENTFSCK
;;
- hook=*)
- HOOK="${ARGUMENT#hook=}"
- export HOOK
- ;;
-
ftpfs=*)
FTPFS="${ARGUMENT#ftpfs=}"
export FTPFS
@@ -125,10 +121,17 @@ Arguments ()
export HTTPFS
;;
- hostname=*)
- HOSTNAME="${ARGUMENT#hostname=}"
- LIVECONF="changed"
- export HOSTNAME LIVECONF
+ iscsi=*)
+ ISCSI="${ARGUMENT#iscsi=}"
+ #ip:port - separated by ;
+ ISCSI_PORTAL="${ISCSI%;*}"
+ if echo "${ISCSI_PORTAL}" | grep -q , ; then
+ ISCSI_SERVER="${ISCSI_PORTAL%,*}"
+ ISCSI_PORT="${ISCSI_PORTAL#*,}"
+ fi
+ #target name
+ ISCSI_TARGET="${ISCSI#*;}"
+ export ISCSI ISCSI_PORTAL ISCSI_TARGET ISCSI_SERVER ISCSI_PORT
;;
isofrom=*|fromiso=*)
@@ -136,18 +139,6 @@ Arguments ()
export FROMISO
;;
- username=*)
- USERNAME="${ARGUMENT#username=}"
- LIVECONF="changed"
- export USERNAME LIVECONF
- ;;
-
- userfullname=*)
- USERFULLNAME="${ARGUMENT#userfullname=}"
- LIVECONF="changed"
- export USERFULLNAME LIVECONF
- ;;
-
ignore_uuid)
IGNORE_UUID="Yes"
export IGNORE_UUID
@@ -169,31 +160,6 @@ Arguments ()
export STATICIP
;;
- keyb=*|kbd-chooser/method=*)
- KBD="${ARGUMENT#*=}"
- export KBD
- ;;
-
- klayout=*|console-setup/layoutcode=*)
- KLAYOUT="${ARGUMENT#*=}"
- export KLAYOUT
- ;;
-
- kvariant=*|console-setup/variantcode=*)
- KVARIANT="${ARGUMENT#*=}"
- export KVARIANT
- ;;
-
- kmodel=*|console-setup/modelcode=*)
- KMODEL="${ARGUMENT#*=}"
- export KMODEL
- ;;
-
- koptions=*)
- KOPTIONS="${ARGUMENT#koptions=}"
- export KOPTIONS
- ;;
-
live-getty)
LIVE_GETTY="1"
export LIVE_GETTY
@@ -224,17 +190,6 @@ Arguments ()
export LIVE_MEDIA_TIMEOUT
;;
- language=*|debian-installer/language=*)
- language=${x#debian-installer/language=}
- locale="$(lang2locale "$language")"
- set_locale="true"
- ;;
-
- locale=*|debian-installer/locale=*)
- LOCALE="${ARGUMENT#*=}"
- export LOCALE
- ;;
-
module=*)
MODULE="${ARGUMENT#module=}"
export MODULE
@@ -260,31 +215,6 @@ Arguments ()
export NOACCESSIBILITY
;;
- noapparmor)
- NOAPPARMOR="Yes"
- export NOAPPARMOR
- ;;
-
- noaptcdrom)
- NOAPTCDROM="Yes"
- export NOAPTCDROM
- ;;
-
- noautologin)
- NOAUTOLOGIN="Yes"
- export NOAUTOLOGIN
- ;;
-
- noxautologin)
- NOXAUTOLOGIN="Yes"
- export NOXAUTOLOGIN
- ;;
-
- noconsolekeyboard)
- NOCONSOLEKEYBOARD="Yes"
- export NOCONSOLEKEYBOARD
- ;;
-
nofastboot)
NOFASTBOOT="Yes"
export NOFASTBOOT
@@ -295,54 +225,13 @@ Arguments ()
export NOFSTAB
;;
- nognomepanel)
- NOGNOMEPANEL="Yes"
- export NOGNOMEPANEL
- ;;
-
- nohosts)
- NOHOSTS="Yes"
- export NOHOSTS
- ;;
-
- nokpersonalizer)
- NOKPERSONALIZER="Yes"
- export NOKPERSONALIZER
- ;;
-
- nolanguageselector)
- NOLANGUAGESELECTOR="Yes"
- export NOLANGUAGESELECTOR
- ;;
-
- nolocales)
- NOLOCALES="Yes"
- export NOLOCALES
- ;;
-
nonetworking)
NONETWORKING="Yes"
export NONETWORKING
;;
- nopowermanagement)
- NOPOWERMANAGEMENT="Yes"
- export NOPOWERMANAGEMENT
- ;;
-
- noprogramcrashes)
- NOPROGRAMCRASHES="Yes"
- export NOPROGRAMCRASHES
- ;;
-
- nojockey)
- NOJOCKEY="Yes"
- export NOJOCKEY
- ;;
-
- nosudo)
- NOSUDO="Yes"
- export NOSUDO
+ ramdisk-size=*)
+ ramdisk_size="${ARGUMENT#ramdisk-size=}"
;;
swapon)
@@ -350,26 +239,6 @@ Arguments ()
export SWAPON
;;
- noupdatenotifier)
- NOUPDATENOTIFIER="Yes"
- export NOUPDATENOTIFIER
- ;;
-
- nouser)
- NOUSER="Yes"
- export NOUSER
- ;;
-
- noxautoconfig)
- NOXAUTOCONFIG="Yes"
- export NOXAUTOCONFIG
- ;;
-
- noxscreensaver)
- NOXSCREENSAVER="Yes"
- export NOXSCREENSAVER
- ;;
-
persistent)
PERSISTENT="Yes"
export PERSISTENT
@@ -401,33 +270,29 @@ Arguments ()
export NOPERSISTENT
;;
- preseed/file=*|file=*)
- LOCATION="${ARGUMENT#*=}"
- export LOCATION
+ noprompt)
+ NOPROMPT="Yes"
+ export NOPROMPT
;;
- nopreseed)
- NOPRESEED="Yes"
- export NOPRESEED
+ noprompt=*)
+ NOPROMPT="${ARGUMENT#noprompt=}"
+ export NOPROMPT
;;
- url=*)
- location="${ARGUMENT#url=}"
-
- mount -o bind /sys /root/sys
- mount -o bind /proc /root/proc
- mount -o bind /dev /root/dev
-
- mkdir -p /root/var/run/network
- [ "${NETBOOT}" ] || chroot /root dhclient eth0
- chroot /root wget -P /tmp "${location}"
- [ "${NETBOOT}" ] || chroot /root ifconfig eth0 down
+ quickusbmodules)
+ QUICKUSBMODULES="Yes"
+ export QUICKUSBMODULES
+ ;;
- umount /root/sys
- umount /root/proc
- umount /root/dev
+ preseed/file=*|file=*)
+ LOCATIONS="${ARGUMENT#*=} ${LOCATIONS}"
+ export LOCATIONS
+ ;;
- LOCATION="/tmp/$(basename "${location}")"
+ nopreseed)
+ NOPRESEED="Yes"
+ export NOPRESEED
;;
*/*=*)
@@ -447,21 +312,6 @@ Arguments ()
export SILENT
;;
- textonly)
- TEXTONLY="Yes"
- export TEXTONLY
- ;;
-
- timezone=*)
- TIMEZONE="${ARGUMENT#timezone=}"
- export TIMEZONE
- ;;
-
- notimezone)
- NOTIMEZONE="Yes"
- export NOTIMEZONE
- ;;
-
todisk=*)
TODISK="${ARGUMENT#todisk=}"
export TODISK
@@ -489,9 +339,9 @@ Arguments ()
;;
skipunion)
- SKIP_UNION_MOUNTS="Yes"
- export SKIP_UNION_MOUNTS
- ;;
+ SKIP_UNION_MOUNTS="Yes"
+ export SKIP_UNION_MOUNTS
+ ;;
root=*)
ROOT="${ARGUMENT#root=}"
@@ -502,26 +352,6 @@ Arguments ()
UNIONTYPE="${ARGUMENT#union=}"
export UNIONTYPE
;;
-
- utc=*)
- UTC="${ARGUMENT#utc=}"
- export UTC
- ;;
-
- xdebconf)
- XDEBCONF="Yes"
- export XDEBCONF
- ;;
-
- xdriver=*)
- XDRIVER="${ARGUMENT#xdriver=}"
- export XDRIVER
- ;;
-
- xvideomode=*)
- XVIDEOMODE="${ARGUMENT#xvideomode=}"
- export XVIDEOMODE
- ;;
esac
done
@@ -650,12 +480,18 @@ is_nice_device ()
{
sysfs_path="${1#/sys}"
- if /lib/udev/path_id "${sysfs_path}" | grep -E -q "ID_PATH=(usb|pci-[^-]*-(ide|scsi|usb)|platform-mmc)"
+ if /lib/udev/path_id "${sysfs_path}" | egrep -q "ID_PATH=(usb|pci-|platform-sata_mv|platform-orion-ehci|platform-mmc|platform-mxsdhci|)"
then
return 0
elif echo "${sysfs_path}" | grep -q '^/block/vd[a-z]$'
then
return 0
+ elif echo ${sysfs_path} | grep -q "^/block/dm-"
+ then
+ return 0
+ elif echo ${sysfs_path} | grep -q "^/block/mtdblock"
+ then
+ return 0
fi
return 1
@@ -685,7 +521,7 @@ copy_live_to ()
if [ "${copytodev}" = "ram" ]
then
# copying to ram:
- freespace=$( expr $(awk '/MemFree/{print $2}' /proc/meminfo) + $( awk '/\<Cached/{print $2}' /proc/meminfo ) )
+ freespace=$(awk '/^MemFree:/{f=$2} /^Cached:/{c=$2} END{print f+c}' /proc/meminfo)
mount_options="-o size=${size}k"
free_string="memory"
fstype="tmpfs"
@@ -710,6 +546,13 @@ copy_live_to ()
return 1
fi
+ # Custom ramdisk size
+ if [ -z "${mount_options}" ] && [ -n "${ramdisk_size}" ]
+ then
+ # FIXME: should check for wrong values
+ mount_options="-o size=${ramdisk_size}"
+ fi
+
# begin copying (or uncompressing)
mkdir "${copyto}"
log_begin_msg "mount -t ${fstype} ${mount_options} ${dev} ${copyto}"
@@ -739,7 +582,11 @@ copy_live_to ()
rsync -a --progress ${copyfrom}/* ${copyto} 1>/dev/console # "cp -a" from busybox also copies hidden files
else
mkdir -p ${copyto}/${LIVE_MEDIA_PATH}
- cp -a ${copyfrom}/${LIVE_MEDIA_PATH}/* ${copyto}/${LIVE_MEDIA_PATH} # "cp -a" from busybox also copies hidden files
+ cp -a ${copyfrom}/${LIVE_MEDIA_PATH}/* ${copyto}/${LIVE_MEDIA_PATH}
+ if [ -e ${copyfrom}/${LIVE_MEDIA_PATH}/.disk ]
+ then
+ cp -a ${copyfrom}/${LIVE_MEDIA_PATH}/.disk ${copyto}
+ fi
fi
fi
@@ -751,49 +598,177 @@ copy_live_to ()
return 0
}
-do_netmount ()
+do_netsetup ()
{
- rc=1
-
modprobe -q af_packet # For DHCP
- if [ -x /sbin/udevadm ]
+ udevadm trigger
+ udevadm settle
+
+ [ -n "$ETHDEV_TIMEOUT" ] || ETHDEV_TIMEOUT=15
+ echo "Using timeout of $ETHDEV_TIMEOUT seconds for network configuration."
+
+ if [ -z "${NETBOOT}" ] && [ -z "${FETCH}" ] && \
+ [ -z "${HTTPFS}" ] && [ -z "${FTPFS}" ]
then
- # lenny
- udevadm trigger
- udevadm settle
- else
- # etch
- udevtrigger
- udevsettle
- fi
- ipconfig ${DEVICE} | tee /netboot.config
- # source relevant ipconfig output
- OLDHOSTNAME=${HOSTNAME}
- . /tmp/net-${DEVICE}.conf
- [ -z ${HOSTNAME} ] && HOSTNAME=${OLDHOSTNAME}
- export HOSTNAME
+ # support for Syslinux IPAPPEND parameter
+ # it sets the BOOTIF variable on the kernel parameter
- # Check if we have a network device at all
- if ! ls /sys/class/net/eth0 > /dev/null 2>&1 && \
- ! ls /sys/class/net/wlan0 > /dev/null 2>&1 && \
- ! ls /sys/class/net/ath0 > /dev/null 2>&1 && \
- ! ls /sys/class/net/ra0 > /dev/null 2>&1
+ if [ -n "${BOOTIF}" ]
then
- panic "No supported network device found, maybe a non-mainline driver is required."
+ # pxelinux sets BOOTIF to a value based on the mac address of the
+ # network card used to PXE boot, so use this value for DEVICE rather
+ # than a hard-coded device name from initramfs.conf. this facilitates
+ # network booting when machines may have multiple network cards.
+ # pxelinux sets BOOTIF to 01-$mac_address
+
+ # strip off the leading "01-", which isn't part of the mac
+ # address
+ temp_mac=${BOOTIF#*-}
+
+ # convert to typical mac address format by replacing "-" with ":"
+ bootif_mac=""
+ IFS='-'
+ for x in $temp_mac
+ do
+ if [ -z "$bootif_mac" ]
+ then
+ bootif_mac="$x"
+ else
+ bootif_mac="$bootif_mac:$x"
+ fi
+ done
+ unset IFS
+
+ # look for devices with matching mac address, and set DEVICE to
+ # appropriate value if match is found.
+
+ for device in /sys/class/net/*
+ do
+ if [ -f "$device/address" ]
+ then
+ current_mac=$(cat "$device/address")
+
+ if [ "$bootif_mac" = "$current_mac" ]
+ then
+ DEVICE=${device##*/}
+ break
+ fi
+ fi
+ done
fi
+ # if ethdevice was not specified on the kernel command line
+ # make sure we try to get a working network configuration
+ # for *every* present network device (except for loopback of course)
+ if [ -z "$ETHDEVICE" ] ; then
+ echo "If you want to boot from a specific device use bootoption ethdevice=..."
+ for device in /sys/class/net/*; do
+ dev=${device##*/} ;
+ if [ "$dev" != "lo" ] ; then
+ ETHDEVICE="$ETHDEVICE $dev"
+ fi
+ done
+ fi
+
+ # split args of ethdevice=eth0,eth1 into "eth0 eth1"
+ for device in $(echo $ETHDEVICE | sed 's/,/ /g') ; do
+ devlist="$devlist $device"
+ done
+
+ # this is tricky (and ugly) because ipconfig sometimes just hangs/runs into
+ # an endless loop; iff execution fails give it two further tries, that's
+ # why we use '$devlist $devlist $devlist' for the other for loop
+ for dev in $devlist $devlist $devlist ; do
+ echo "Executing ipconfig -t $ETHDEV_TIMEOUT $dev"
+ ipconfig -t "$ETHDEV_TIMEOUT" $dev | tee -a /netboot.config &
+ jobid=$!
+ sleep "$ETHDEV_TIMEOUT" ; sleep 1
+ if [ -r /proc/"$jobid"/status ] ; then
+ echo "Killing job $jobid for device $dev as ipconfig ran into recursion..."
+ kill -9 $jobid
+ fi
+
+ # if configuration of device worked we should have an assigned
+ # IP address, iff so let's use the according as $DEVICE for later usage
+ # simple and primitive approach which seems to work fine
+ if ifconfig $dev | grep -q 'inet.*addr:' ; then
+ export DEVICE="$dev"
+ break
+ fi
+ done
+
+ else
+ for interface in ${DEVICE}; do
+ ipconfig -t "$ETHDEV_TIMEOUT" ${interface} | tee /netboot-${interface}.config
+ [ -e /tmp/net-${interface}.conf ] && . /tmp/net-${interface}.conf
+ if [ "$IPV4ADDR" != "0.0.0.0" ]
+ then
+ break
+ fi
+ done
+ fi
+
+ for interface in ${DEVICE}; do
+ # source relevant ipconfig output
+ OLDHOSTNAME=${HOSTNAME}
+ [ -e /tmp/net-${interface}.conf ] && . /tmp/net-${interface}.conf
+ [ -z ${HOSTNAME} ] && HOSTNAME=${OLDHOSTNAME}
+ export HOSTNAME
+
+ if [ -n "${interface}" ]
+ then
+ HWADDR="$(cat /sys/class/net/${interface}/address)"
+ fi
+
+ if [ ! -e "/etc/resolv.conf" ]
+ then
+ echo "Creating /etc/resolv.conf"
+
+ if [ -n "${DNSDOMAIN}" ]
+ then
+ echo "domain ${DNSDOMAIN}" > /etc/resolv.conf
+ echo "search ${DNSDOMAIN}" >> /etc/resolv.conf
+ fi
+
+ for i in ${IPV4DNS0} ${IPV4DNS1} ${IPV4DNS1}
+ do
+ if [ -n "$i" ] && [ "$i" != 0.0.0.0 ]
+ then
+ echo "nameserver $i" >> /etc/resolv.conf
+ fi
+ done
+ fi
+
+ # Check if we have a network device at all
+ if ! ls /sys/class/net/"$interface" > /dev/null 2>&1 && \
+ ! ls /sys/class/net/eth0 > /dev/null 2>&1 && \
+ ! ls /sys/class/net/wlan0 > /dev/null 2>&1 && \
+ ! ls /sys/class/net/ath0 > /dev/null 2>&1 && \
+ ! ls /sys/class/net/ra0 > /dev/null 2>&1
+ then
+ panic "No supported network device found, maybe a non-mainline driver is required."
+ fi
+ done
+}
+
+do_netmount()
+{
+ do_netsetup
+
if [ "${NFSROOT}" = "auto" ]
then
NFSROOT=${ROOTSERVER}:${ROOTPATH}
fi
- if ( [ -n "${FETCH}" ] || [ -n "${HTTPFS}" ] || [ -n "${FTPFS}" ] ) && do_httpmount
+ rc=1
+
+ if ( [ -n "${FETCH}" ] || [ -n "${HTTPFS}" ] || [ -n "${FTPFS}" ] )
then
- rc=0
- return ${rc}
+ do_httpmount
+ return $?
fi
if [ "${NFSROOT#*:}" = "${NFSROOT}" ] && [ "$NETBOOT" != "cifs" ]
@@ -817,22 +792,76 @@ do_netmount ()
return ${rc}
}
+do_iscsi()
+{
+ do_netsetup
+ #modprobe ib_iser
+ modprobe iscsi_tcp
+ local debugopt=""
+ [ "${DEBUG}" == "Yes" ] && debugopt="-d 8"
+ #FIXME this name is supposed to be unique - some date + ifconfig hash?
+ ISCSI_INITIATORNAME="iqn.1993-08.org.debian.live:01:$(echo "${HWADDR}" | sed -e s/://g)"
+ export ISCSI_INITIATORNAME
+ if [ -n "${ISCSI_SERVER}" ] ; then
+ iscsistart $debugopt -i "${ISCSI_INITIATORNAME}" -t "${ISCSI_TARGET}" -g 1 -a "${ISCSI_SERVER}" -p "${ISCSI_PORT}"
+ else
+ iscsistart $debugopt -i "${ISCSI_INITIATORNAME}" -t "${ISCSI_TARGET}" -g 1 -a "${ISCSI_PORTAL}" -p 3260
+ fi
+ if [ $? != 0 ]
+ then
+ panic "Failed to log into iscsi target"
+ fi
+ local host="$(ls -d /sys/class/scsi_host/host*/device/iscsi_host:host* \
+ /sys/class/scsi_host/host*/device/iscsi_host/host* | sed -e 's:/device.*::' -e 's:.*host::')"
+ if [ -n "${host}" ]
+ then
+ local devices=""
+ local i=0
+ while [ -z "${devices}" -a $i -lt 60 ]
+ do
+ sleep 1
+ devices="$(ls -d /sys/class/scsi_device/${host}*/device/block:* \
+ /sys/class/scsi_device/${host}*/device/block/* | sed -e 's!.*[:/]!!')"
+ i=$(expr $i + 1)
+ echo -ne $i\\r
+ done
+ for dev in $devices
+ do
+ if check_dev "null" "/dev/$dev"
+ then
+ NETBOOT="iscsi"
+ export NETBOOT
+ return 0;
+ fi
+ done
+ panic "Failed to locate a live device on iSCSI devices (tried: $devices)."
+ else
+ panic "Failed to locate iSCSI host in /sys"
+ fi
+}
+
do_httpmount ()
{
rc=1
- dest="${mountpoint}/${LIVE_MEDIA_PATH}"
- mount -t ramfs ram "${mountpoint}"
- mkdir -p "${dest}"
for webfile in HTTPFS FTPFS FETCH
do
- url="$(eval echo \"\$\{${webfile}\}\")"
- extension="$(echo "${url}" | sed 's/\(.*\)\.\(.*\)/\2/')"
+ local url="$(eval echo \"\$\{${webfile}\}\")"
+ local extension="$(echo "${url}" | sed 's/\(.*\)\.\(.*\)/\2/')"
if [ -n "$url" ]
then
case "${extension}" in
- squashfs|tgz|tar)
+ iso|squashfs|tgz|tar)
+ if [ "${extension}" = "iso" ]
+ then
+ mkdir -p "${alt_mountpoint}"
+ dest="${alt_mountpoint}"
+ else
+ local dest="${mountpoint}/${LIVE_MEDIA_PATH}"
+ mount -t ramfs ram "${mountpoint}"
+ mkdir -p "${dest}"
+ fi
if [ "${webfile}" = "FETCH" ]
then
case "$url" in
@@ -860,9 +889,16 @@ do_httpmount ()
fi
modprobe fuse
$FUSE_MOUNT "${url}" "${dest}"
+ ROOT_PID="$(minips h -C "$FUSE_MOUNT" | { read x y ; echo "$x" ; } )"
fi
[ ${?} -eq 0 ] && rc=0
[ "${extension}" = "tgz" ] && live_dest="ram"
+ if [ "${extension}" = "iso" ]
+ then
+ isoloop=$(setup_loop "${dest}/$(basename "${url}")" "loop" "/sys/block/loop*" "" '')
+ mount -t iso9660 "${isoloop}" "${mountpoint}"
+ rc=${?}
+ fi
break
;;
@@ -875,7 +911,15 @@ do_httpmount ()
if [ ${rc} != 0 ]
then
- umount "${mountpoint}"
+ if [ -d "${alt_mountpoint}" ]
+ then
+ umount "${alt_mountpoint}"
+ rmdir "${alt_mountpoint}"
+ fi
+ umount "${mountpoint}"
+ elif [ "${webfile}" != "FETCH" ] ; then
+ NETBOOT="${webfile}"
+ export NETBOOT
fi
return ${rc}
@@ -940,13 +984,15 @@ do_snap_copy ()
if [ -b "${fromdev}" ]
then
+ log_success_msg "Copying snapshot ${fromdev} to ${todir}..."
+
# look for free mem
if [ -n "${HOMEMOUNTED}" -a "${snap_type}" = "HOME" ]
then
todev=$(awk -v pat="$(base_path ${todir})" '$2 == pat { print $1 }' /proc/mounts)
freespace=$(df -k | awk '/'${todev}'/{print $4}')
else
- freespace=$( expr $(awk '/MemFree/{print $2}' /proc/meminfo) + $( awk '/\<Cached/{print $2}' /proc/meminfo))
+ freespace=$(awk '/^MemFree:/{f=$2} /^Cached:/{c=$2} END{print f+c}' /proc/meminfo)
fi
tomount="/mnt/tmpsnap"
@@ -977,9 +1023,8 @@ do_snap_copy ()
return 0
else
- return 1
-
log_warning_msg "Unable to find the snapshot ${snap_type} medium"
+ return 1
fi
}
@@ -987,28 +1032,39 @@ find_snap ()
{
# Look for ${snap_label}.* in block devices
snap_label="${1}"
+ black_listed_devices="${2}"
if [ "${PERSISTENT}" != "nofiles" ]
then
# search for image files
- snapdata=$(find_files "${snap_label}.squashfs ${snap_label}.cpio.gz ${snap_label}.ext2 ${snap_label}.ext3 ${snap_label}.ext4 ${snap_label}.jffs2")
+ snapdata=$(find_files "${PERSISTENT_PATH}${snap_label}.squashfs ${PERSISTENT_PATH}${snap_label}.cpio.gz ${PERSISTENT_PATH}${snap_label}.ext2 ${PERSISTENT_PATH}${snap_label}.ext3 ${PERSISTENT_PATH}${snap_label}.ext4 ${PERSISTENT_PATH}${snap_label}.jffs2" "${black_listed_devices}")
fi
if [ -z "${snapdata}" ]
then
- snapdata=$(find_cow_device "${snap_label}")
+ snapdata=$(find_cow_device "${snap_label}" "${black_listed_devices}")
fi
echo "${snapdata}"
}
try_snap ()
{
- # copy the contents of previously found snapshot to ${snap_mount}
- # and remember the device and filename for resync on exit in live-initramfs.init
+ # copy the contents of previously found snapshot to ${snap_mount}
+ # and remember the device and filename for resync on exit in live-boot.init
snapdata="${1}"
snap_mount="${2}"
snap_type="${3}"
+ snap_relpath="${4}"
+
+ if [ -z "${snap_relpath}" ]
+ then
+ # root snapshot, default usage
+ snap_relpath="/"
+ else
+ # relative snapshot (actually used just for "/home" snapshots)
+ snap_mount="${2}${snap_relpath}"
+ fi
if [ -n "${snapdata}" ] && [ ! -b "${snapdata}" ]
then
@@ -1017,29 +1073,50 @@ try_snap ()
snapback="$(echo ${snapdata} | cut -f2 -d ' ')"
snapfile="$(echo ${snapdata} | cut -f3 -d ' ')"
- RES=""
if ! try_mount "${snapdev}" "${snapback}" "ro"
then
break
fi
+ RES="0"
+
if echo "${snapfile}" | grep -qs '\(squashfs\|ext2\|ext3\|ext4\|jffs2\)'
then
# squashfs, jffs2 or ext2/ext3/ext4 snapshot
dev=$(get_backing_device "${snapback}/${snapfile}")
do_snap_copy "${dev}" "${snap_mount}" "${snap_type}"
- RES=$?
+ RES="$?"
else
# cpio.gz snapshot
- cd "${snap_mount}"
- zcat "${snapback}/${snapfile}" | /bin/cpio --extract --preserve-modification-time --no-absolute-filenames --sparse --unconditional --make-directories > /dev/null 2>&1
- RES=$?
+
+ # Unfortunately klibc's cpio is incompatible with the
+ # rest of the world; everything else requires -u -d,
+ # while klibc doesn't implement them. Try to detect
+ # whether it's in use.
+ cpiopath="$(which cpio)" || true
+ if [ "$cpiopath" ] && grep -aq /lib/klibc "$cpiopath"
+ then
+ cpioargs=
+ else
+ cpioargs='--unconditional --make-directories'
+ fi
+
+ if [ -s "${snapback}/${snapfile}" ]
+ then
+ BEFOREDIR="$(pwd)"
+ cd "${snap_mount}" && zcat "${snapback}/${snapfile}" | $cpiopath $cpioargs --extract --preserve-modification-time --no-absolute-filenames --sparse 2>/dev/null
+ RES="$?"
+ cd "${BEFOREDIR}"
+ else
+ log_warning_msg "${snapback}/${snapfile} is empty, adding it for sync on reboot."
+ RES="0"
+ fi
+
if [ "${RES}" != "0" ]
then
- log_warning_msg "failure to \"zcat ${snapback}/${snapfile} | /bin/cpio --extract --preserve-modification-time --no-absolute-filenames --sparse --unconditional --make-directories\""
+ log_warning_msg "failure to \"zcat ${snapback}/${snapfile} | $cpiopath $cpioargs --extract --preserve-modification-time --no-absolute-filenames --sparse\""
fi
- cd "${OLDPWD}"
fi
umount "${snapback}" || log_warning_msg "failure to \"umount ${snapback}\""
@@ -1066,7 +1143,7 @@ try_snap ()
if ! do_snap_copy "${dev}" "${snap_mount}" "${snap_type}"
then
- log_warning_msg "Impossible to include the ${snap_type} Snapshot"
+ log_warning_msg "Impossible to include the ${snap_type} Snapshot (i)"
return 1
else
if [ -n "${snapfile}" ]
@@ -1076,11 +1153,11 @@ try_snap ()
fi
fi
else
- log_warning_msg "Impossible to include the ${snap_type} Snapshot"
+ log_warning_msg "Impossible to include the ${snap_type} Snapshot (o)"
return 1
fi
- echo "export ${snap_type}SNAP="${snap_mount}":${snapdev}:${snapfile}" >> /etc/live.conf # for resync on reboot/halt
+ echo "export ${snap_type}SNAP=${snap_relpath}:${snapdev}:${snapfile}" >> snapshot.conf # for resync on reboot/halt
return 0
}
@@ -1088,8 +1165,26 @@ setup_unionfs ()
{
image_directory="${1}"
rootmnt="${2}"
- addimage_directory="${3}"
- modprobe -q -b ${UNIONTYPE}
+ addimage_directory="${3}"
+
+ case ${UNIONTYPE} in
+ aufs|unionfs)
+ modprobe -q -b ${UNIONTYPE}
+
+ if ! cut -f2 /proc/filesystems | grep -q "^${UNIONTYPE}\$" && [ -x /bin/unionfs-fuse ]
+ then
+ echo "${UNIONTYPE} not available, falling back to unionfs-fuse."
+ echo "This might be really slow."
+
+ UNIONTYPE="unionfs-fuse"
+ fi
+ ;;
+ esac
+
+ if [ "${UNIONTYPE}" = unionfs-fuse ]
+ then
+ modprobe fuse
+ fi
# run-init can't deal with images in a subdir, but we're going to
# move all of these away before it runs anyway. No, we're not,
@@ -1099,17 +1194,15 @@ setup_unionfs ()
croot="/"
# Let's just mount the read-only file systems first
- rofsstring=""
rofslist=""
- minor_kernel_version=$(uname -r|cut -c 5-|sed 's/[^0-9].*//')
- if [ "${NETBOOT}" = "nfs" ] && [ "${minor_kernel_version}" -lt 22 ]
- then
- # go aroung a bug in nfs-unionfs locking for unionfs <= 1.4
- roopt="nfsro"
- elif [ "${UNIONTYPE}" = "aufs" ]
+ if [ "${UNIONTYPE}" = "aufs" ]
then
roopt="rr"
+ noxino_opt="noxino,"
+ elif [ "${UNIONTYPE}" = "unionfs-fuse" ]
+ then
+ roopt="RO"
else
roopt="ro"
fi
@@ -1160,7 +1253,7 @@ setup_unionfs ()
image_string="$(echo ${image_string} | sed -e 's/ /\n/g' | sort )"
fi
- [ -n "${MODULETORAMFILE}" ] && image_string="${image_directory}/$(basename ${MODULETORAMFILE})"
+ [ -n "${MODULETORAMFILE}" ] && image_string="${image_directory}/$(basename ${MODULETORAMFILE})"
mkdir -p "${croot}"
@@ -1177,7 +1270,6 @@ setup_unionfs ()
if [ -d "${image}" ]
then
# it is a plain directory: do nothing
- rofsstring="${image}=${roopt}:${rofsstring}"
rofslist="${image} ${rofslist}"
elif [ -f "${image}" ]
then
@@ -1200,9 +1292,17 @@ setup_unionfs ()
log_warning_msg "Unknown file system type on ${backdev} (${image}), assuming ${fstype}."
fi
- mkdir -p "${croot}/${imagename}"
- log_begin_msg "Mounting \"${image}\" on \"${croot}${imagename}\" via \"${backdev}\""
- mount -t "${fstype}" -o ro,noatime "${backdev}" "${croot}/${imagename}" || panic "Can not mount ${backdev} (${image}) on ${croot}/${imagename}" && rofsstring="${croot}/${imagename}=${roopt}:${rofsstring}" && rofslist="${croot}/${imagename} ${rofslist}"
+ if [ "${UNIONTYPE}" != "unionmount" ]
+ then
+ mpoint="${croot}/${imagename}"
+ rofslist="${mpoint} ${rofslist}"
+ else
+ mpoint="${rootmnt}"
+ rofslist="${rootmnt} ${rofslist}"
+ fi
+ mkdir -p "${mpoint}"
+ log_begin_msg "Mounting \"${image}\" on \"${mpoint}\" via \"${backdev}\""
+ mount -t "${fstype}" -o ro,noatime "${backdev}" "${mpoint}" || panic "Can not mount ${backdev} (${image}) on ${mpoint}"
log_end_msg
fi
done
@@ -1210,50 +1310,45 @@ setup_unionfs ()
# we have a plain root system
mkdir -p "${croot}/filesystem"
log_begin_msg "Mounting \"${image_directory}\" on \"${croot}/filesystem\""
- mount -t $(get_fstype "${image_directory}") -o ro,noatime "${image_directory}" "${croot}/filesystem" || panic "Can not mount ${image_directory} on ${croot}/filesystem" && rofsstring="${croot}/filesystem=${roopt}:${rofsstring}" && rofslist="${croot}/filesystem ${rofslist}"
+ mount -t $(get_fstype "${image_directory}") -o ro,noatime "${image_directory}" "${croot}/filesystem" || \
+ panic "Can not mount ${image_directory} on ${croot}/filesystem" && \
+ rofslist="${croot}/filesystem ${rofslist}"
# probably broken:
mount -o bind ${croot}/filesystem $mountpoint
log_end_msg
fi
- rofsstring=${rofsstring%:}
-
mkdir -p /cow
# Looking for "${root_persistence}" device or file
if [ -n "${PERSISTENT}" ] && [ -z "${NOPERSISTENT}" ]
then
- # Load USB modules
- num_block=$(ls -l /sys/block | wc -l)
- for module in sd_mod uhci-hcd ehci-hcd ohci-hcd usb-storage
- do
- modprobe -q -b ${module}
- done
-
- if [ -x /sbin/udevadm ]
+ if [ -z "${QUICKUSBMODULES}" ]
then
- # lenny
+ # Load USB modules
+ num_block=$(ls -l /sys/block | wc -l)
+ for module in sd_mod uhci-hcd ehci-hcd ohci-hcd usb-storage
+ do
+ modprobe -q -b ${module}
+ done
+
udevadm trigger
udevadm settle
- else
- # etch
- udevtrigger
- udevsettle
- fi
- # For some reason, udevsettle does not block in this scenario,
- # so we sleep for a little while.
- #
- # See https://bugs.launchpad.net/ubuntu/+source/casper/+bug/84591
- for timeout in 5 4 3 2 1
- do
- sleep 1
+ # For some reason, udevsettle does not block in this scenario,
+ # so we sleep for a little while.
+ #
+ # See https://bugs.launchpad.net/ubuntu/+source/casper/+bug/84591
+ for timeout in 5 4 3 2 1
+ do
+ sleep 1
- if [ $(ls -l /sys/block | wc -l) -gt ${num_block} ]
- then
- break
- fi
- done
+ if [ $(ls -l /sys/block | wc -l) -gt ${num_block} ]
+ then
+ break
+ fi
+ done
+ fi
# search for label and files (this could be hugely optimized)
cowprobe=$(find_cow_device "${root_persistence}")
@@ -1321,29 +1416,33 @@ setup_unionfs ()
cow_mountopt="rw,noatime,mode=755"
fi
- if [ "${cow_fstype}" = "nfs" ]
+ if [ "${UNIONTYPE}" != "unionmount" ]
then
- log_begin_msg \
- "Trying nfsmount ${nfs_cow_opts} ${cowdevice} /cow"
- nfsmount ${nfs_cow_opts} ${cowdevice} /cow || \
- panic "Can not mount ${cowdevice} (n: ${cow_fstype}) on /cow"
- else
- mount -t ${cow_fstype} -o ${cow_mountopt} ${cowdevice} /cow || \
- panic "Can not mount ${cowdevice} (o: ${cow_fstype}) on /cow"
+
+ if [ "${cow_fstype}" = "nfs" ]
+ then
+ log_begin_msg \
+ "Trying nfsmount ${nfs_cow_opts} ${cowdevice} /cow"
+ nfsmount ${nfs_cow_opts} ${cowdevice} /cow || \
+ panic "Can not mount ${cowdevice} (n: ${cow_fstype}) on /cow"
+ else
+ mount -t ${cow_fstype} -o ${cow_mountopt} ${cowdevice} /cow || \
+ panic "Can not mount ${cowdevice} (o: ${cow_fstype}) on /cow"
+ fi
fi
rofscount=$(echo ${rofslist} |wc -w)
- if [ -n "${EXPOSED_ROOT}" ]
+ if [ ${rofscount} -ne 1 ]
then
- if [ ${rofscount} -ne 1 ]
- then
- panic "only one RO file system supported with exposedroot: ${rofslist}"
- fi
- exposedrootfs=${rofslist%% }
+ panic "only one RO file system supported with exposedroot: ${rofslist}"
+ fi
+ rofs=${rofslist%% }
- mount --bind ${exposedrootfs} ${rootmnt} || \
- panic "bind mount of ${exposedrootfs} failed"
+ if [ -n "${EXPOSED_ROOT}" ]
+ then
+ mount --bind ${rofs} ${rootmnt} || \
+ panic "bind mount of ${rofs} failed"
if [ -z "${SKIP_UNION_MOUNTS}" ]
then
@@ -1351,21 +1450,50 @@ setup_unionfs ()
else
cow_dirs=''
fi
-
- for dir in ${cow_dirs}; do
- mkdir -p /cow${dir}
- mount -t ${UNIONTYPE} \
- -o rw,noatime,dirs=/cow${dir}=rw:${exposedrootfs}${dir}=ro \
- ${UNIONTYPE} "${rootmnt}${dir}" || \
- panic "mount ${UNIONTYPE} on ${rootmnt}${dir} failed with option \
- rw,noatime,dirs=/cow${dir}=rw:${exposedrootfs}${dir}=ro"
- done
else
- mount -t ${UNIONTYPE} -o noatime,dirs=/cow=rw:${rofsstring} \
- ${UNIONTYPE} "${rootmnt}" || panic "mount ${UNIONTYPE} on \
- ${rootmnt} failed with option noatime,dirs=/cow=rw:${rofsstring}"
+ cow_dirs="/"
fi
+ if [ "${cow_fstype}" != "tmpfs" ] && [ "${cow_dirs}" != "/" ] && [ "${UNIONTYPE}" = "unionmount" ]
+ then
+ true # FIXME: Maybe it does, I don't really know.
+ #panic "unionmount does not support subunions (${cow_dirs})."
+ fi
+
+ unionmountopts=""
+ unionmountpoint=""
+
+ for dir in ${cow_dirs}; do
+ mkdir -p /cow${dir}
+
+ unionmountpoint="${rootmnt}${dir}"
+ unionrw="/cow${dir}"
+ unionro="${rofs}${dir}"
+ # We don't handle spaces and other junk gracefully here, hopefully not needed.
+ case "${UNIONTYPE}" in
+ unionfs-fuse)
+ unionmountopts="-o cow -o noinitgroups -o default_permissions -o allow_other -o use_ino -o suid"
+ unionmountopts="${unionmountopts} ${unionrw}=RW:${unionro}=RO"
+ ( sysctl -w fs.file-max=391524 ; ulimit -HSn 16384
+ unionfs-fuse ${unionmountopts} "${unionmountpoint}" ) && \
+ ( mkdir -p /run/sendsigs.omit.d
+ pidof unionfs-fuse >> /run/sendsigs.omit.d/unionfs-fuse || true )
+ ;;
+
+ unionmount)
+ unionmountopts="-t ${cow_fstype} -o noatime,union,${cow_mountopt} ${cowdevice}"
+ mount_full $unionmountopts "${unionmountpoint}"
+ ;;
+
+
+ *)
+ unionmountopts="-o noatime,${noxino_opt}dirs=${unionrw}=rw:${unionro}=${roopt}"
+ mount -t ${UNIONTYPE} ${unionmountopts} ${UNIONTYPE} "${unionmountpoint}"
+ ;;
+ esac || \
+ panic "mount ${UNIONTYPE} on ${unionmountpoint} failed with option ${unionmountopts}"
+ done
+
# Correct the permissions of /:
chmod 0755 "${rootmnt}"
@@ -1391,7 +1519,7 @@ setup_unionfs ()
# Look for other snapshots to copy in
try_snap "${root_snapdata}" "${rootmnt}" "ROOT"
# This second type should be removed when snapshot grow smarter
- try_snap "${home_snapdata}" "${rootmnt}/home" "HOME"
+ try_snap "${home_snapdata}" "${rootmnt}" "HOME" "/home"
fi
if [ -n "${SHOWMOUNTS}" ]
@@ -1406,7 +1534,15 @@ setup_unionfs ()
;;
*)
- mount -o move "${d}" "${rootmnt}/live/${d##*/}"
+ case "${UNIONTYPE}" in
+ unionfs-fuse)
+ mount -o bind "${d}" "${rootmnt}/live/${d##*/}"
+ ;;
+
+ *)
+ mount -o move "${d}" "${rootmnt}/live/${d##*/}"
+ ;;
+ esac
;;
esac
done
@@ -1423,19 +1559,40 @@ check_dev ()
devname="${2}"
skip_uuid_check="${3}"
-
- # fixed by Jaromil to support FAT usb partitions
- is_supported_fs vfat
-
# support for fromiso=.../isofrom=....
if [ -n "$FROMISO" ]
then
- mkdir -p /isofrom
- ISO_DEVICE="$(echo $FROMISO | sed 's|\(/dev/[a-z]*[0-9]*\).*|\1|')"
- mount "$ISO_DEVICE" /isofrom
- ISO_NAME="$(echo $FROMISO | sed 's|/dev/[a-z]*[0-9]*/||')"
- loopdevname=$(setup_loop "/isofrom/${ISO_NAME}" "loop" "/sys/block/loop*" "" '')
- devname="${loopdevname}"
+ ISO_DEVICE=$(dirname $FROMISO)
+ if ! [ -b $ISO_DEVICE ]
+ then
+ # to support unusual device names like /dev/cciss/c0d0p1
+ # as well we have to identify the block device name, let's
+ # do that for up to 15 levels
+ i=15
+ while [ -n "$ISO_DEVICE" ] && [ "$i" -gt 0 ]
+ do
+ ISO_DEVICE=$(dirname ${ISO_DEVICE})
+ [ -b "$ISO_DEVICE" ] && break
+ i=$(($i -1))
+ done
+ fi
+
+ if [ "$ISO_DEVICE" = "/" ]
+ then
+ echo "Warning: device for bootoption isofrom= ($FROMISO) not found.">>/live-boot.log
+ else
+ fs_type=$(get_fstype "${ISO_DEVICE}")
+ if is_supported_fs ${fs_type}
+ then
+ mkdir /isofrom
+ mount -t $fs_type "$ISO_DEVICE" /isofrom
+ ISO_NAME="$(echo $FROMISO | sed "s|$ISO_DEVICE||")"
+ loopdevname=$(setup_loop "/isofrom/${ISO_NAME}" "loop" "/sys/block/loop*" "" '')
+ devname="${loopdevname}"
+ else
+ echo "Warning: unable to mount $ISO_DEVICE." >>/live-boot.log
+ fi
+ fi
fi
if [ -z "${devname}" ]
@@ -1456,6 +1613,36 @@ check_dev ()
fi
fi
+ IFS=","
+ for device in ${devname}
+ do
+ case "$device" in
+ *mapper*)
+ # Adding lvm support
+ if [ -x /scripts/local-top/lvm2 ]
+ then
+ ROOT="$device" resume="" /scripts/local-top/lvm2
+ fi
+ ;;
+
+ /dev/md*)
+ # Adding raid support
+ if [ -x /scripts/local-top/mdadm ]
+ then
+ cp /conf/conf.d/md /conf/conf.d/md.orig
+ echo "MD_DEVS=$device " >> /conf/conf.d/md
+ /scripts/local-top/mdadm
+ mv /conf/conf.d/md.orig /conf/conf.d/md
+ fi
+ ;;
+ esac
+ done
+ unset IFS
+
+ [ -n "$device" ] && devname="$device"
+
+ [ -e "$devname" ] || continue
+
if [ -n "${LIVE_MEDIA_OFFSET}" ]
then
loopdevname=$(setup_loop "${devname}" "loop" "/sys/block/loop*" "${LIVE_MEDIA_OFFSET}" '')
@@ -1466,7 +1653,10 @@ check_dev ()
if is_supported_fs ${fstype}
then
+ devuid=$(blkid -o value -s UUID "$devname")
+ [ -n "$devuid" ] && grep -qs "\<$devuid\>" $tried && continue
mount -t ${fstype} -o ro,noatime "${devname}" ${mountpoint} || continue
+ [ -n "$devuid" ] && echo "$devuid" >> $tried
if is_live_path ${mountpoint} && \
([ "${skip_uuid_check}" ] || matches_uuid ${mountpoint})
@@ -1506,8 +1696,7 @@ find_livefs ()
do
if [ "$(cat ${sysblock}/removable)" = "1" ]
then
- if readlink ${sysblock} | grep -q usb ||
- readlink ${sysblock}/device | grep -q usb # linux < 2.6.29
+ if readlink ${sysblock} | grep -q usb
then
for dev in $(subdevices "${sysblock}")
do
@@ -1519,6 +1708,7 @@ find_livefs ()
fi
fi
done
+ return 1
;;
removable)
@@ -1535,6 +1725,7 @@ find_livefs ()
done
fi
done
+ return 1
;;
*)
@@ -1549,9 +1740,22 @@ find_livefs ()
esac
# or do the scan of block devices
- for sysblock in $(echo /sys/block/* | tr ' ' '\n' | grep -vE "/(loop|ram|dm-|fd)")
+ # prefer removable devices over non-removable devices, so scan them first
+ for sysblock in $(echo /sys/block/* | tr ' ' '\n' | egrep -v "/(loop|ram|dm-|fd)")
+ do
+ if [ "$(cat ${sysblock}/removable)" = "1" ]
+ then
+ removable_devices_to_scan="$removable_devices_to_scan $sysblock"
+ else
+ nonremovable_devices_to_scan="$nonremovable_devices_to_scan $sysblock"
+ fi
+ done
+ devices_to_scan="$removable_devices_to_scan $nonremovable_devices_to_scan"
+
+ for sysblock in $devices_to_scan
do
devname=$(sys2dev "${sysblock}")
+ [ -e "$devname" ] || continue
fstype=$(get_fstype "${devname}")
if /lib/udev/cdrom_id ${devname} > /dev/null
@@ -1570,6 +1774,7 @@ find_livefs ()
fi
done
elif [ "${fstype}" = "squashfs" -o \
+ "${fstype}" = "btrfs" -o \
"${fstype}" = "ext2" -o \
"${fstype}" = "ext3" -o \
"${fstype}" = "ext4" -o \
@@ -1577,7 +1782,7 @@ find_livefs ()
then
# This is an ugly hack situation, the block device has
# an image directly on it. It's hopefully
- # live-initramfs, so take it and run with it.
+ # live-boot, so take it and run with it.
ln -s "${devname}" "${devname}.${fstype}"
echo "${devname}.${fstype}"
return 0
@@ -1587,16 +1792,6 @@ find_livefs ()
return 1
}
-set_usplash_timeout ()
-{
- if [ -x /sbin/usplash_write ]
- then
- /sbin/usplash_write "TIMEOUT 120"
- else if [ -x /sbin/splashy_update ] ; then
- /sbin/splashy_update "TIMEOUT 120"
- fi ; fi
-}
-
integrity_check ()
{
media_mountpoint="${1}"
@@ -1625,15 +1820,15 @@ integrity_check ()
mountroot ()
{
- if [ -x /scripts/local-top/cryptroot ]; then
+ if [ -x /scripts/local-top/cryptroot ]; then
/scripts/local-top/cryptroot
fi
exec 6>&1
exec 7>&2
- exec > live.log
+ exec > live-boot.log
exec 2>&1
- tail -f live.log >&7 &
+ tail -f live-boot.log >&7 &
tailpid="${!}"
# Ensure 'panic' function is overridden
@@ -1641,8 +1836,6 @@ mountroot ()
Arguments
- set_usplash_timeout
-
maybe_break live-premount
log_begin_msg "Running /scripts/live-premount"
run_scripts /scripts/live-premount
@@ -1651,8 +1844,6 @@ mountroot ()
# Needed here too because some things (*cough* udev *cough*)
# changes the timeout
- set_usplash_timeout
-
if [ ! -z "${NETBOOT}" ] || [ ! -z "${FETCH}" ] || [ ! -z "${HTTPFS}" ] || [ ! -z "${FTPFS}" ]
then
if do_netmount
@@ -1662,11 +1853,28 @@ mountroot ()
panic "Unable to find a live file system on the network"
fi
else
- if [ -n "${PLAIN_ROOT}" ] && [ -n "${ROOT}" ]
+ if [ -n "${ISCSI_PORTAL}" ]
+ then
+ do_iscsi && livefs_root="${mountpoint}"
+ elif [ -n "${PLAIN_ROOT}" ] && [ -n "${ROOT}" ]
then
# Do a local boot from hd
livefs_root=${ROOT}
else
+ if [ -x /usr/bin/memdiskfind ]
+ then
+ MEMDISK=$(/usr/bin/memdiskfind)
+
+ if [ $? -eq 0 ]
+ then
+ # We found a memdisk, set up phram
+ modprobe phram phram=memdisk,${MEMDISK}
+
+ # Load mtdblock, the memdisk will be /dev/mtdblock0
+ modprobe mtdblock
+ fi
+ fi
+
# Scan local devices for the image
i=0
while [ "$i" -lt 60 ]
@@ -1727,16 +1935,65 @@ mountroot ()
mount_images_in_directory "${livefs_root}" "${rootmnt}" "${mac}"
fi
+
+ if [ -n "${ROOT_PID}" ] ; then
+ echo "${ROOT_PID}" > "${rootmnt}"/live/root.pid
+ fi
+
log_end_msg
+ # unionfs-fuse needs /dev to be bind-mounted for the duration of
+ # live-bottom; udev's init script will take care of things after that
+ if [ "${UNIONTYPE}" = unionfs-fuse ]
+ then
+ mount -n -o bind /dev "${rootmnt}/dev"
+ fi
+
+ # Move to the new root filesystem so that programs there can get at it.
+ if [ ! -d /root/live/image ]
+ then
+ mkdir -p /root/live/image
+ mount --move /live/image /root/live/image
+ fi
+
+ # aufs2 in kernel versions around 2.6.33 has a regression:
+ # directories can't be accessed when read for the first the time,
+ # causing a failure for example when accessing /var/lib/fai
+ # when booting FAI, this simple workaround solves it
+ ls /root/* >/dev/null 2>&1
+
+ # copy snapshot configuration if exists
+ if [ -f snapshot.conf ]
+ then
+ log_begin_msg "Copying snapshot.conf to ${rootmnt}/etc/live/boot.d"
+ if [ ! -d "${rootmnt}/etc/live/boot.d" ]
+ then
+ mkdir -p "${rootmnt}/etc/live/boot.d"
+ fi
+ cp snapshot.conf "${rootmnt}/etc/live/boot.d/"
+ log_end_msg
+ fi
+
+ if [ -f /etc/resolv.conf ] && [ ! -s ${rootmnt}/etc/resolv.conf ]
+ then
+ log_begin_msg "Copying /etc/resolv.conf to ${rootmnt}/etc/resolv.conf"
+ cp -v /etc/resolv.conf ${rootmnt}/etc/resolv.conf
+ log_end_msg
+ fi
+
maybe_break live-bottom
log_begin_msg "Running /scripts/live-bottom\n"
run_scripts /scripts/live-bottom
log_end_msg
+ if [ "${UNIONFS}" = unionfs-fuse ]
+ then
+ umount "${rootmnt}/dev"
+ fi
+
exec 1>&6 6>&-
exec 2>&7 7>&-
kill ${tailpid}
- [ -w "${rootmnt}/var/log/" ] && cp live.log "${rootmnt}/var/log/" 2>/dev/null
+ [ -w "${rootmnt}/var/log/" ] && cp live-boot.log "${rootmnt}/var/log/" 2>/dev/null
}
diff --git a/dyneIII/live-init-scripts/scripts/live-bottom/08persistence_excludes b/dyneIII/live-init-scripts/scripts/live-bottom/08persistence_excludes
index b7aac92..43639f9 100755
--- a/dyneIII/live-init-scripts/scripts/live-bottom/08persistence_excludes
+++ b/dyneIII/live-init-scripts/scripts/live-bottom/08persistence_excludes
@@ -24,7 +24,7 @@ case "${1}" in
;;
esac
-# live-initramfs header
+# live-boot header
if [ -z "${PERSISTENT}" ] || [ -n "${NOPERSISTENT}" ] || [ -z "${PERSISTENCE_IS_ON}" ] || [ ! -f /root/etc/live-persistence.binds ]
then
@@ -33,7 +33,7 @@ fi
. /scripts/live-functions
-# live-initramfs script
+# live-boot script
dirs="$(sed -e '/^ *$/d' -e '/^#.*$/d' /root/etc/live-persistence.binds | tr '\n' '\0')"
if [ -z "${dirs}" ]
diff --git a/dyneIII/live-init-scripts/scripts/live-bottom/12fstab b/dyneIII/live-init-scripts/scripts/live-bottom/12fstab
index cbc180b..ba4a7a3 100755
--- a/dyneIII/live-init-scripts/scripts/live-bottom/12fstab
+++ b/dyneIII/live-init-scripts/scripts/live-bottom/12fstab
@@ -19,7 +19,7 @@ case "${1}" in
;;
esac
-# live-initramfs header
+# live-boot header
. /scripts/live-functions
@@ -30,7 +30,7 @@ fi
log_begin_msg "Configuring fstab"
-# live-initramfs script
+# live-boot script
# Create a fake fstab only if it doesn't exist or if its the debootstrap template
if [ ! -f "${FSTAB}" ] || grep -qs 'UNCONFIGURED FSTAB FOR BASE SYSTEM' "${FSTAB}"
@@ -66,7 +66,7 @@ then
continue
fi
- /lib/udev/blkid -o udev ${device%%[0-9]*} 2>/dev/null | grep -q "^ID_FS_USAGE=raid" && continue
+ /sbin/blkid -o udev -p ${device%%[0-9]*} | grep -q "^ID_FS_USAGE=raid" && continue
magic=$(/bin/dd if="${device}" bs=4086 skip=1 count=1 2>/dev/null | /bin/dd bs=10 count=1 2>/dev/null) || continue
diff --git a/dyneIII/live-init-scripts/scripts/live-bottom/23networking b/dyneIII/live-init-scripts/scripts/live-bottom/23networking
index 72aaf12..86d4562 100755
--- a/dyneIII/live-init-scripts/scripts/live-bottom/23networking
+++ b/dyneIII/live-init-scripts/scripts/live-bottom/23networking
@@ -18,7 +18,7 @@ case "${1}" in
;;
esac
-# live-initramfs header
+# live-boot header
if [ -n "${NONETWORKING}" ]
then
@@ -29,7 +29,7 @@ fi
log_begin_msg "Preconfiguring networking"
-# live-initramfs script
+# live-boot script
IFFILE="/root/etc/network/interfaces"
@@ -46,40 +46,40 @@ iface lo inet loopback
EOF
-if [ -x /sbin/udevadm ]
-then
- # lenny
- udevadm trigger
- udevadm settle
-else
- # etch
- udevtrigger
- udevsettle
-fi
+udevadm trigger
+udevadm settle
if [ -z "${NETBOOT}" -a -n "${STATICIP}" -a "${STATICIP}" != "frommedia" ]
then
- parsed=$(echo "${STATICIP}" | sed -e 's/:/ /g')
+ parsed=$(echo "${STATICIP}" | sed -e 's/,/ /g')
for ifline in ${parsed}
do
- ifname="$(echo ${ifline} | cut -f1 -d ',')"
- ifaddress="$(echo ${ifline} | cut -f2 -d ',')"
- ifnetmask="$(echo ${ifline} | cut -f3 -d ',')"
- ifgateway="$(echo ${ifline} | cut -f4 -d ',')"
+ ifname="$(echo ${ifline} | cut -f1 -d ':')"
+ ifaddress="$(echo ${ifline} | cut -f2 -d ':')"
+ ifnetmask="$(echo ${ifline} | cut -f3 -d ':')"
+ ifgateway="$(echo ${ifline} | cut -f4 -d ':')"
cat >> "${IFFILE}" << EOF
-auto ${ifname}
+allow-hotplug ${ifname}
iface ${ifname} inet static
address ${ifaddress}
netmask ${ifnetmask}
+EOF
+
+if [ -n "${ifgateway}" ]
+then
+
+cat >> "${IFFILE}" << EOF
gateway ${ifgateway}
EOF
+fi
+
done
else
- if [ -z "${NETBOOT}" ]
+ if [ -z "${NETBOOT}" ] || [ -n "${DHCP}" ]
then
# default, dhcp assigned
method="dhcp"
@@ -89,8 +89,8 @@ else
method="manual"
fi
- # iterate the physical interfaces and add them to the interfaces list
- if [ "${method}" != dhcp ] || ([ ! -x /root/usr/sbin/NetworkManager ] && [ ! -x /root/usr/sbin/wicd ])
+ # iterate the physical interfaces and add them to the interfaces list and also add when ethdevice= called on cmdline
+ if [ "${method}" != dhcp ] || ([ ! -x /root/usr/sbin/NetworkManager ] && [ ! -x /root/usr/sbin/wicd ]) || [ ! -z "${ETHDEVICE}" ]
then
for interface in /sys/class/net/eth* /sys/class/net/ath* /sys/class/net/wlan*
do
@@ -98,7 +98,7 @@ else
i="$(basename ${interface})"
cat >> "${IFFILE}" << EOF
-auto ${i}
+allow-hotplug ${i}
iface ${i} inet ${method}
EOF
@@ -127,7 +127,7 @@ EOF
cat > /root/etc/resolv.conf << EOF
# /etc/resolv.conf
-# Autogenerated by live-initramfs
+# Autogenerated by live-boot
search ${rc_search}
domain ${rc_search}
${rc_server0}
@@ -146,7 +146,7 @@ fi
# grep -q "iface ${i}" ${IFFILE} && continue
#
#cat >> "${IFFILE}" << EOF
-#auto ${i}
+#allow-hotplug ${i}
#iface ${i} inet dhcp
#
#EOF
diff --git a/dyneIII/live-init-scripts/scripts/live-bottom/24preseed b/dyneIII/live-init-scripts/scripts/live-bottom/24preseed
index 2536bd0..85c6494 100755
--- a/dyneIII/live-init-scripts/scripts/live-bottom/24preseed
+++ b/dyneIII/live-init-scripts/scripts/live-bottom/24preseed
@@ -18,7 +18,7 @@ case "${1}" in
;;
esac
-# live-initramfs header
+# live-boot header
if [ -n "${NOPRESEED}" ]
then
@@ -29,16 +29,19 @@ fi
log_begin_msg "Loading preseed file"
-# live-initramfs script
+# live-boot script
if [ -e /preseed.cfg ]
then
chroot /root debconf-set-selections < /preseed.cfg
fi
-if [ -f "/root/${LOCATION}" ]
+if [ -n "${LOCATIONS}" ]
then
- chroot /root debconf-set-selections < "/root/${LOCATION}"
+ for item in ${LOCATIONS}
+ do
+ chroot /root debconf-set-selections < "/root${item}"
+ done
fi
if [ -n "${PRESEEDS}" ]
@@ -52,7 +55,7 @@ then
done
fi
-reply="$(echo "GET preseed/early_command" | chroot /root debconf-communicate -fnoninteractive live-initramfs)"
+reply="$(echo "GET preseed/early_command" | chroot /root debconf-communicate -fnoninteractive live-boot)"
if [ "${reply#0 }" != "${reply}" ]
then
diff --git a/dyneIII/live-init-scripts/scripts/live-bottom/30accessibility b/dyneIII/live-init-scripts/scripts/live-bottom/30accessibility
index 3c51fa0..4ed1c6d 100755
--- a/dyneIII/live-init-scripts/scripts/live-bottom/30accessibility
+++ b/dyneIII/live-init-scripts/scripts/live-bottom/30accessibility
@@ -18,7 +18,7 @@ case "${1}" in
;;
esac
-# live-initramfs header
+# live-boot header
if [ -n "${NOACCESSIBILITY}" ]
then
@@ -35,7 +35,7 @@ fi
log_begin_msg "Configuring accessibility options"
-# live-initramfs script
+# live-boot script
gconf_version=$(chroot /root /usr/bin/dpkg-query -W --showformat='${Version}' gconf2 2>/dev/null) || gconf_version=""
@@ -57,6 +57,7 @@ remove_applet ()
local line_no prior_line next_line
line_no="$(grep -n "<string>$1</string>" /root/usr/share/gconf/defaults/05_panel-default-setup.entries | cut -f 1 -d :)"
+ [ "$line_no" ] || return
prior_line="$((line_no-1))"
next_line="$((line_no+1))"
@@ -65,6 +66,17 @@ remove_applet ()
chroot /root update-gconf-defaults
}
+add_sudoers_file ()
+{
+
+cat <<EOF > /root/etc/sudoers.d/a11y-sudo
+# TO allow accessibility in GTK to work with sudo.
+Defaults env_keep = "ORBIT_SOCKETDIR XDG_SESSION_COOKIE GTK_MODULES"
+EOF
+
+ chmod 0440 /root/etc/sudoers.d/a11y-sudo
+}
+
case ${ACCESS} in
access=v1)
# Lesser Visual Impairment
@@ -89,7 +101,7 @@ case ${ACCESS} in
gct -s -t string /desktop/gnome/applications/at/visual/exec orca
gct -s -t bool /apps/gksu/disable-grab true
gct -s -t string /desktop/gnome/applications/window_manager/default /usr/bin/metacity
- sed -i -e 's/# Host alias specification/Defaults\tenv_keep = "ORBIT_SOCKETDIR XDG_SESSION_COOKIE GTK_MODULES"\n\n# Host alias specification/g' /root/etc/sudoers
+ add_sudoers_file
if [ -x /root/usr/bin/orca ]
then
@@ -108,19 +120,12 @@ case ${ACCESS} in
gct -s -t bool /desktop/gnome/interface/accessibility true
gct -s -t bool /desktop/gnome/applications/at/visual/startup true
gct -s -t string /desktop/gnome/applications/at/visual/exec orca
+ gct -s -t string /apps/empathy/conversation/theme classic
gct -s -t bool /apps/gksu/disable-grab true
gct -s -t string /desktop/gnome/applications/window_manager/default /usr/bin/metacity
- sed -i -e 's/# Host alias specification/Defaults\tenv_keep = "ORBIT_SOCKETDIR XDG_SESSION_COOKIE GTK_MODULES"\n\n# Host alias specification/g' /root/etc/sudoers
+ add_sudoers_file
remove_applet fast_user_switch
- if [ -x /root/usr/bin/pulse-session ]
- then
- touch /root/home/$USERNAME/.pulse_a11y_nostart
- chroot /root chown $USERNAME.$USERNAME /home/$USERNAME/.pulse_a11y_nostart
- mkdir -p /root/home/$USERNAME/.pulse
- echo "autospawn = no" > /root/home/$USERNAME/.pulse/client.conf
- chroot /root chown -R $USERNAME.$USERNAME /home/$USERNAME/.pulse
- fi
if [ -x /root/usr/bin/orca ]
then
mkdir -p /root/home/$USERNAME/.orca
@@ -135,7 +140,8 @@ case ${ACCESS} in
gct -s -t string /desktop/gnome/applications/at/visual/exec orca
gct -s -t bool /apps/gksu/disable-grab true
gct -s -t string /desktop/gnome/applications/window_manager/default /usr/bin/metacity
- sed -i -e 's/# Host alias specification/Defaults\tenv_keep = "ORBIT_SOCKETDIR XDG_SESSION_COOKIE GTK_MODULES"\n\n# Host alias specification/g' /root/etc/sudoers
+ gct -s -t string /apps/empathy/conversation/theme classic
+ add_sudoers_file
if [ -x /root/usr/bin/orca ]
then
@@ -147,15 +153,6 @@ case ${ACCESS} in
chroot /root chown -R ${USERNAME}:${USERNAME} /home/${USERNAME}/.orca
fi
- if [ -x /root/usr/bin/pulse-session ]
- then
- touch /root/home/$USERNAME/.pulse_a11y_nostart
- chroot /root chown $USERNAME.$USERNAME /home/$USERNAME/.pulse_a11y_nostart
- mkdir -p /root/home/$USERNAME/.pulse
- echo "autospawn = no" > /root/home/$USERNAME/.pulse/client.conf
- chroot /root chown -R $USERNAME.$USERNAME /home/$USERNAME/.pulse
- fi
-
remove_applet fast_user_switch
;;
diff --git a/dyneIII/live-init-scripts/scripts/live-functions b/dyneIII/live-init-scripts/scripts/live-functions
index 4a23e69..f426ff9 100644
--- a/dyneIII/live-init-scripts/scripts/live-functions
+++ b/dyneIII/live-init-scripts/scripts/live-functions
@@ -5,13 +5,11 @@
log_wait_msg ()
{
# Print a message and wait for enter
- if [ -x /sbin/usplash_write ]
+ if [ -x /bin/plymouth ] && plymouth --ping
then
- /sbin/usplash_write "INPUTENTER ${@}"
- read nunya < /dev/.initramfs/usplash_outfifo
- else if [ -x /sbin/splashy_update ] ; then
- /sbin/splashy_update "getstring ${@}" | read nunya
- fi ; fi
+ plymouth message --text="$@"
+ plymouth watch-keystroke | read nunya
+ fi
_log_msg "Waiting: ${@} ... \n"
}
@@ -35,7 +33,7 @@ lang2locale() {
langpart="${1%%_*}"
if [ "$1" != "C" ]; then
# Match the language code with 3rd field in languagelist
- line=$(grep -v "^#" /usr/share/live-initramfs/languagelist | cut -f1,3,6 -d\; | grep -v ';C$' | grep "^$langpart;")
+ line=$(grep -v "^#" /usr/share/live-boot/languagelist | cut -f1,3,6 -d\; | grep -v ';C$' | grep "^$langpart;")
if [ -n "$line" ]; then
if [ "$(echo "$line" | grep -c '')" -gt 1 ]; then
# More than one match; try matching the
@@ -78,7 +76,7 @@ panic() {
DEB_3="\033[1;31m\`. \`'\` \033[0m"
DEB_4="\033[1;31m \`- \033[0m"
- LIVELOG="\033[1;37m/live.log\033[0m"
+ LIVELOG="\033[1;37m/live-boot.log\033[0m"
DEBUG="\033[1;37mdebug\033[0m"
# Reset redirections to avoid buffering
@@ -92,7 +90,7 @@ panic() {
printf " ${DEB_3}\n"
printf " ${DEB_4} This Debian Live image failed to boot.\n\n"
- printf " Please file a bug against the 'live-initramfs' package or email the Debian\n"
+ printf " Please file a bug against the 'live-boot' package or email the Debian\n"
printf " Live mailing list at <debian-live@lists.debian.org>, making sure to note the\n"
printf " exact version, name and distribution of the image you were attempting to boot.\n\n"
@@ -101,9 +99,9 @@ panic() {
printf " extremely useful when diagnosing issues.\n\n"
if [ -n "${panic}" ]; then
- printf " live-initramfs will now restart your system. "
+ printf " live-boot will now restart your system. "
else
- printf " live-initramfs will now start a shell. "
+ printf " live-boot will now start a shell. "
fi
printf "The error message was:\n\n "
diff --git a/dyneIII/live-init-scripts/scripts/live-helpers b/dyneIII/live-init-scripts/scripts/live-helpers
index d667376..06bd186 100644
--- a/dyneIII/live-init-scripts/scripts/live-helpers
+++ b/dyneIII/live-init-scripts/scripts/live-helpers
@@ -1,4 +1,4 @@
-# live-initramfs helper functions, used by live-initramfs on boot and by live-snapshot
+# live-boot helper functions, used by live-boot on boot and by live-snapshot
if [ ! -x "/bin/fstype" ]
then
@@ -26,7 +26,7 @@ subdevices ()
sysblock=${1}
r=""
- for dev in "${sysblock}" "${sysblock}"/*
+ for dev in "${sysblock}"/* "${sysblock}"
do
if [ -e "${dev}/dev" ]
then
@@ -76,12 +76,7 @@ is_supported_fs ()
get_fstype ()
{
- if [ -x /lib/udev/vol_id ]
- then
- /lib/udev/vol_id -t ${1} 2>/dev/null
- else
- /lib/udev/blkid -o value -s TYPE ${1} 2>/dev/null
- fi
+ /sbin/blkid -s TYPE -o value $1 2>/dev/null
}
where_is_mounted ()
@@ -184,16 +179,13 @@ setup_loop ()
local encryption=${5}
local readonly=${6}
- modprobe -q -b "${module}"
+ # the output of setup_loop is evaluated in other functions,
+ # modprobe leaks kernel options like "libata.dma=0"
+ # as "options libata dma=0" on stdout, causing serious
+ # problems therefor, so instead always avoid output to stdout
+ modprobe -q -b "${module}" 1>/dev/null
- if [ -x /sbin/udevadm ]
- then
- # lenny
- udevadm settle
- else
- # etch
- udevsettle
- fi
+ udevadm settle
for loopdev in ${pattern}
do
@@ -282,7 +274,8 @@ try_mount ()
then
fstype=$(get_fstype "${dev}")
fi
- mount -t "${fstype}" -o "${opts}" "${dev}" "${mountp}" || panic "Cannot mount ${dev} on ${mountp}, fstype=${fstype}, options=${opts}"
+ mount -t "${fstype}" -o "${opts}" "${dev}" "${mountp}" || \
+ ( echo "SKIPPING: Cannot mount ${dev} on ${mountp}, fstype=${fstype}, options=${opts}" > live-boot.log && return 0 )
fi
}
@@ -304,13 +297,21 @@ find_cow_device ()
for sysblock in $(echo /sys/block/* | tr ' ' '\n' | grep -v loop | grep -v ram | grep -v fd)
do
+ fulldevname=$(sys2dev "${sysblock}")
+
+ if echo "${black_listed_devices}" | grep -q -w "${fulldevname}"
+ then
+ # skip this device entirely
+ break
+ fi
+
for dev in $(subdevices "${sysblock}")
do
devname=$(sys2dev "${dev}")
- if echo "${black_listed_devices}" | grep -q "${devname}"
+ if echo "${black_listed_devices}" | grep -q -w "${devname}"
then
- # skip this device enterely
+ # skip this subdevice
break
fi
@@ -344,8 +345,7 @@ find_cow_device ()
done
fi
- #if [ "$(/lib/udev/vol_id -l ${devname} 2>/dev/null)" = "${pers_label}" ]
- if [ "$(/lib/udev/blkid -o value -s LABEL ${devname} 2>/dev/null)" = "${pers_label}" ]
+ if [ "$(/sbin/blkid -s LABEL -o value $devname 2>/dev/null)" = "${pers_label}" ]
then
echo "${devname}"
return 0
@@ -361,17 +361,15 @@ find_cow_device ()
case "$(get_fstype ${devname})" in
vfat|ext2|ext3|ext4|jffs2)
mkdir -p "${cow_backing}"
- if ! try_mount "${devname}" "${cow_backing}" "rw"
+ if try_mount "${devname}" "${cow_backing}" "rw"
then
- break
- fi
-
- if [ -f "${pers_fpath}" ]
- then
- echo $(setup_loop "${pers_fpath}" "loop" "/sys/block/loop*")
- return 0
- else
- umount ${cow_backing}
+ if [ -f "${pers_fpath}" ]
+ then
+ echo $(setup_loop "${pers_fpath}" "loop" "/sys/block/loop*")
+ return 0
+ else
+ umount ${cow_backing} > /dev/null 2>&1 || true
+ fi
fi
;;
*)
@@ -393,14 +391,22 @@ find_files ()
for sysblock in $(echo /sys/block/* | tr ' ' '\n' | grep -v loop | grep -v ram | grep -v fd)
do
+ fulldevname=$(sys2dev "${sysblock}")
+
+ if echo "${black_listed_devices}" | grep -q -w "${fulldevname}"
+ then
+ # skip this device entirely
+ break
+ fi
+
for dev in $(subdevices "${sysblock}")
do
devname=$(sys2dev "${dev}")
devfstype="$(get_fstype ${devname})"
- if echo "${black_listed_devices}" | grep -q "${devname}"
+ if echo "${black_listed_devices}" | grep -q -w "${devname}"
then
- # skip this device enterely
+ # skip this subdevice
break
fi
diff --git a/dyneIII/live-init-scripts/scripts/live-premount/modules b/dyneIII/live-init-scripts/scripts/live-premount/modules
index 408e873..1af7a9e 100755
--- a/dyneIII/live-init-scripts/scripts/live-premount/modules
+++ b/dyneIII/live-init-scripts/scripts/live-premount/modules
@@ -18,9 +18,9 @@ case "${1}" in
;;
esac
-# live-initramfs script
+# live-boot script
-# The following modprobe entry is a workaround to live-initramfs not
+# The following modprobe entry is a workaround to live-boot not
# finding the root filesytem.
#
# See also:
diff --git a/dyneIII/live-init-scripts/scripts/live-premount/readonly b/dyneIII/live-init-scripts/scripts/live-premount/readonly
index 8bed733..71483bd 100755
--- a/dyneIII/live-init-scripts/scripts/live-premount/readonly
+++ b/dyneIII/live-init-scripts/scripts/live-premount/readonly
@@ -18,7 +18,7 @@ case "${1}" in
;;
esac
-# live-initramfs script
+# live-boot script
# make sure all harddisk devices are read-only
# this is important for forensic investigations
diff --git a/dyneIII/live-init-scripts/scripts/live-premount/select_eth_device b/dyneIII/live-init-scripts/scripts/live-premount/select_eth_device
new file mode 100755
index 0000000..fe86313
--- /dev/null
+++ b/dyneIII/live-init-scripts/scripts/live-premount/select_eth_device
@@ -0,0 +1,102 @@
+#!/bin/sh
+
+# Original script by Andreas Teuchert <ant+dl@hsg-kl.de>
+# Modified by Frédéric Boiteux <fboiteux@calistel.com>
+
+PREREQ="blacklist udev"
+
+prereqs()
+{
+ echo "$PREREQ"
+}
+
+case $1 in
+# get pre-requisites
+prereqs)
+ prereqs
+ exit 0
+ ;;
+esac
+
+# Boot type in initramfs's config
+bootconf=$(egrep '^BOOT=' /conf/initramfs.conf | tail -1)
+
+# can be superseded by command line (used by Debian-Live's netboot for example)
+for ARGUMENT in $(cat /proc/cmdline); do
+ case "${ARGUMENT}" in
+ netboot=*)
+ NETBOOT="${ARGUMENT#netboot=}"
+ ;;
+ esac
+done
+
+if [ "$bootconf" != "BOOT=nfs" ] &&
+ [ "$NETBOOT" = "" ] &&
+ [ "$FETCH" = "" ] &&
+ [ "$FTPFS" = "" ] &&
+ [ "$HTTPFS" = "" ]
+then
+ # Not a net boot : nothing to do
+ exit 0
+fi
+
+# we want to do some basic IP
+modprobe -q af_packet
+
+# Available Ethernet interfaces ?
+l_interfaces=""
+echo "Waiting for ethernet card(s) up... If this fails, maybe the ethernet card is not supported by the kernel `uname -r`?"
+while [ -z "$l_interfaces" ]; do
+ l_interfaces="$(cd /sys/class/net/ && ls -d eth* 2>/dev/null)"
+done
+
+if [ $(echo $l_interfaces | wc -w) -lt 2 ]; then
+ # only one interface : no choice
+ echo "DEVICE=$l_interfaces" >> /conf/param.conf
+ exit 0
+fi
+
+# If user force to use specific device, write it
+for ARGUMENT in $(cat /proc/cmdline); do
+ case "${ARGUMENT}" in
+ live-netdev=*)
+ NETDEV="${ARGUMENT#live-netdev=}"
+ echo "DEVICE=$NETDEV" >> /conf/param.conf
+ echo "Found live-netdev parameter in /proc/cmdline. Force to use network device $NETDEV."
+ exit 0
+ ;;
+ esac
+done
+
+found_eth_dev=""
+while true; do
+ echo -n "Looking for a connected Ethernet interface ..."
+
+ for interface in $l_interfaces; do
+ # ATTR{carrier} is not set if this is not done
+ echo -n " $interface ?"
+ ipconfig -c none -d $interface -t 1 >/dev/null 2>&1
+ done
+
+ echo ''
+
+ for step in 1 2 3 4 5; do
+ for interface in $l_interfaces; do
+ carrier=$(cat /sys/class/net/$interface/carrier \
+ 2>/dev/null)
+ # link detected
+ if [ "$carrier" = 1 ]; then
+ echo "Connected $interface found"
+ # inform initrd's init script :
+ found_eth_dev="$found_eth_dev $interface"
+ fi
+ done
+ if [ -n "$found_eth_dev" ]; then
+ echo "DEVICE='$found_eth_dev'" >> /conf/param.conf
+ exit 0
+ else
+ # wait a bit
+ sleep 1
+ fi
+ done
+done